<!DOCTYPE html>
<html>
<head>
	<meta charset="utf-8">
	<title></title>
	<!-- Bootstrap CSS -->
	<link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap@4.6.1/dist/css/bootstrap.min.css" integrity="sha384-zCbKRCUGaJDkqS1kPbPd7TveP5iyJE0EjAuZQTgFLD2ylzuqKfdKlfG/eSrtxUkn" crossorigin="anonymous">
</head>
<body>
	<h1 class="text-center my-5">Bootstrap Flex</h1>
	<!-- 
		Flexbox is used to manipulate and layout out elements. This can be done exclusively in CSS. However, using bootstrap it is much easier and faster to implement flex because all we have to do is add the class d-flex to the percent of our flex item.

		Flex items, Flex Children, when adding d-flex to their parent, the items are in a row. We can adjust their height and width not like your inline elements.

		Flex Directions:
		You can change the direction of your flex items by adding flex-direction. however, by default, flex-row is the arrangement of our flex items.

		Flex Row Reverse
		Starts our items from the opposite side(right) and reverse the order of our flex items.

		flex-row starts from left to right.(default)
		flex-row-reverse start to right to left.
		
		flex-column will arrange our items from top to bottom and by default the flex items will occupy the width of its parent

		flex column Reverse
		Does the same as flex-column just the 

	 -->

	 <!-- Flex Row -->
	<h3 class="text-center my-3">Flex Row</h3>
	<div class="bg-dark d-flex mb-4">
		<div class="bg-primary p-2">Flex Item 1</div>
		<div class="bg-danger p-2">Flex Item 2</div>
		<div class="bg-success p-2">Flex Item 3</div>
	</div>

	<!-- Flex Row Span  -->
	<div class="bg-dark d-flex mb-4">
		<span class="bg-primary p-2">Span Flex 1</span>
		<span class="bg-danger p-2">Span Flex 2</span>
		<span class="bg-success p-2">Span Flex 3</span>
	</div>

	<!-- Flex Row Reverse -->
	<h3 class="text-center my-5">Flex Row Reverse</h3>
	<div class="d-flex flex-row-reverse bg-dark mb-4" >
		<div class="bg-primary p-2">Flex Item 1</div>
		<div class="bg-danger p-2">Flex Item 2</div>
		<div class="bg-success p-2">Flex Item 3</div>
	</div>

	<!-- Flex div column -->
	<h3 class="text-center my-5">Flex Column</h3>
	<div class="d-flex flex-column bg-dark mb-4 p-4" >
		<div class="bg-primary p-2">Flex Item 1</div>
		<div class="bg-danger p-2">Flex Item 2</div>
		<div class="bg-success p-2">Flex Item 3</div>
	</div>

	<!-- Flex span column -->
	<div class="bg-dark d-flex flex-column mb-4 p-4">
		<span class="bg-primary p-2">Span Flex 1</span>
		<span class="bg-danger p-2">Span Flex 2</span>
		<span class="bg-success p-2">Span Flex 3</span>
	</div>

	<!-- Flex Column Reverse -->
	<h3 class="text-center my-5">Flex Column Reverse</h3>
	<div class="bg-dark d-flex flex-column-reverse mb-4 p-4">
		<div class="bg-primary p-2">Flex Item 1</div>
		<div class="bg-danger p-2">Flex Item 2</div>
		<div class="bg-success p-2">Flex Item 3</div>
	</div>

	<!-- Justify Content -->
	<h2 class="text-center my-5">Justify Content</h2>
	<!-- justify content allows us to manipulate and change the alignment of our flex items along our main axis. The main axis for flex-row item is our x-axis. justify content allows us to horizontally align our flex-row items -->

	<h3 class="text-center my-5">Justify Content Start</h3>
	<!-- justify content start the default value of justify content for flex items. It allows us to align our flex items to the start of their main axis. For flex-row its starts from the left, for left, for flex-row-reverse it start from the right. -->

	<!-- flex-row justify-content-start -->
	<div class="bg-dark d-flex flex-row justify-content-start center mb-4">
		<div class="bg-primary p-2">Flex Item 1</div>
		<div class="bg-danger p-2">Flex Item 2</div>
		<div class="bg-success p-2">Flex Item 3</div>
	</div>

	<!-- flex-row-reverse justify-content-start -->
	<div class="bg-dark d-flex flex-row-reverse justify-content-start center mb-4">
		<div class="bg-primary p-2">Flex Item 1</div>
		<div class="bg-danger p-2">Flex Item 2</div>
		<div class="bg-success p-2">Flex Item 3</div>
	</div>

	<!-- Flex Row - Justify Content End -->
	<h3 class="text-center my-5">Justify Content End</h3>
	<!-- Aligns our flex items where our main axis ends. For flex-row, the end from right, for flex-row-reverse, the end is from the left. -->
	<div class="bg-dark d-flex flex-row justify-content-end">
		<div class="bg-primary p-2">Flex Item 1</div>
		<div class="bg-danger p-2">Flex Item 2</div>
		<div class="bg-success p-2">Flex Item 3</div>
	</div>

	<!-- Flex Row Reverse - Justify Content End -->
	<div class="bg-dark d-flex flex-row-reverse justify-content-end">
		<div class="bg-primary p-2">Flex Item 1</div>
		<div class="bg-danger p-2">Flex Item 2</div>
		<div class="bg-success p-2">Flex Item 3</div>
	</div>

	<h3 class="text-center my-5">Justify Content Center</h3>
	<!-- Aligns our flex-items at the center of the main x-axis. The main axis for both flex-row and lex-row-reverse is the x-axis. Therefore, with justify-content-center we can center our items horizontally -->
	<div class="bg-dark d-flex flex-row justify-content-center mb-4">
		<div class="bg-primary p-2">Flex Item 1</div>
		<div class="bg-danger p-2">Flex Item 2</div>
		<div class="bg-success p-2">Flex Item 3</div>
	</div>

	<!-- flex-row-reverse justify-content-center -->
	<div class="bg-dark d-flex flex-row-reverse justify-content-center mb-4">
		<div class="bg-primary p-2">Flex Item 1</div>
		<div class="bg-danger p-2">Flex Item 2</div>
		<div class="bg-success p-2">Flex Item 3</div>
	</div>

	<!-- flex-row justify-content-between -->
	<h3 class="text-center my-5"></h3>
	<!-- justify-content-between adds /distributes remain spaces in between our items -->
	
	<!-- flex-row justify-content-between -->
	<div class="d-flex flex-row justify-content-between bg-dark mb-4">
		<div class="bg-primary p-2">Flex Item 1</div>
		<div class="bg-danger p-2">Flex Item 2</div>
		<div class="bg-success p-2">Flex Item 3</div>
		<div class="bg-warning p-2">Flex Item 4</div>
		<div class="bg-info p-2">Flex Item 5</div>
	</div>

	<!-- Flex-Row-Reverse Justify-Content-Between -->
	<div class="d-flex flex-row-reverse justify-content-between bg-dark mb-4">
		<div class="bg-primary p-2">Flex Item 1</div>
		<div class="bg-danger p-2">Flex Item 2</div>
		<div class="bg-success p-2">Flex Item 3</div>
	</div>	

	<!-- Justify Content Around -->
	<h3 class="text-center my-5">Justify Content Around</h3>
	<!-- Aligns our items by distributing space around your items. Meaning it will automatically calculate the space remaining and add that space around your items. -->

	<!-- flex-row justify-content-around -->
	<div class="bg-dark d-flex flex-row justify-content-around mb-4">
		<div class="bg-primary p-2">Flex Item 1</div>
		<div class="bg-danger p-2">Flex Item 2</div>
		<div class="bg-success p-2">Flex Item 3</div>
	</div>

	<!-- flex-row-reverse justify-content-around -->
	<div class="bg-dark d-flex flex-row-reverse justify-content-around mb-4">
		<div class="bg-primary p-2">Flex Item 1</div>
		<div class="bg-danger p-2">Flex Item 2</div>
		<div class="bg-success p-2">Flex Item 3</div>
	</div>

	<!-- Align Items -->
	<h2 class="text-center my-5">Align Items</h2>
	<!-- Align Items - aligns yout items vertically for flex-row and flex-row-reverse -->
	
	<!-- flex-row align-items-start -->
	<h3>Align Items Start</h3>
	<!-- align-items-start - aligns items at the start of the y axis or cross-axis for flex-row and flex-row -reverse.

	For flex-row and flex-reverse, the y-axis is the cross axis and the x-axis is their main axis.

	For flex-column and flex-column-reverse, the y-axis is the main axis and x-axis is the their cross axis.

	For flex-row and flex-row-reverse, the start of the their y-axis is at the top
	 -->
	<div class="d-flex flex-row align-items-start bg-dark mb-4" style="height: 50vh;">
		<div class="bg-primary p-2">Flex Item 1</div>
		<div class="bg-danger p-2">Flex Item 2</div>
		<div class="bg-success p-2">Flex Item 3</div>
	</div>

	<!-- flex-row-reverse align-items-start -->
	<div class="d-flex flex-row-reverse align-items-start bg-dark mb-4" style="height: 50vh;">
		<div class="bg-primary p-2">Flex Item 1</div>
		<div class="bg-danger p-2">Flex Item 2</div>
		<div class="bg-success p-2">Flex Item 3</div>
	</div>

	<h3 class="text-center my-5">Align Items End</h3>
	<!-- align-items-end will align our flex-row and flex-row-reverse items at  -->

	<!-- flex-row align-items-end -->
	<div class="bg-dark flex-row align-items-end mb-4" style="height:50vh;">
		<div class="bg-primary p-2">Flex Item 1</div>
		<div class="bg-danger p-2">Flex Item 2</div>
		<div class="bg-success p-2">Flex Item 3</div>
	</div>

	<!-- flex-row-reverse align-items-end -->
	<div class="bg-dark flex-row-reverse align-items-end mb-4" style="height:50vh;">
		<div class="bg-primary p-2">Flex Item 1</div>
		<div class="bg-danger p-2">Flex Item 2</div>
		<div class="bg-success p-2">Flex Item 3</div>
	</div>

	<h3 class="text-center my-5">Align Items Center</h3>
	<!-- align-items-center - allows us to align our flex -->
	<div class="d-flex flex-row align-items-center bg-dark mb-4" style="height:50vh;">
		<div class="bg-primary p-2">Flex Item 1</div>
		<div class="bg-danger p-2">Flex Item 2</div>
		<div class="bg-success p-2">Flex Item 3</div>
	</div>

	<div class="d-flex flex-row-reverse align-items-center bg-dark mb-4" style="height:50vh;">
		<div class="bg-primary p-2">Flex Item 1</div>
		<div class="bg-danger p-2">Flex Item 2</div>
		<div class="bg-success p-2">Flex Item 3</div>
	</div>


	<h2 class="text-center my-5">Aligning Items Horizontally and Vertically</h2>
	
	<!-- flex-row align-items-end justify-content-end -->
	<div class="d-flex flex-row align-items-end justify-content-end bg-dark mb-4" style="height:50vh;">
		<div class="bg-primary p-2">Flex Item 1</div>
		<div class="bg-danger p-2">Flex Item 2</div>
		<div class="bg-success p-2">Flex Item 3</div>
	</div>

	<!-- flex-row align-items-end justify-content-around -->
	<div class="d-flex flex-row align-items-end justify-content-around bg-dark mb-4" style="height:50vh;">
		<div class="bg-primary p-2">Flex Item 1</div>
		<div class="bg-danger p-2">Flex Item 2</div>
		<div class="bg-success p-2">Flex Item 3</div>
	</div>

	<!-- flex-row align-items-end justify-content-end -->
	<div class="d-flex flex-row align-items-center justify-content-end bg-dark mb-4" style="height:50vh;">
		<div class="bg-primary p-2">Flex Item 1</div>
		<div class="bg-danger p-2">Flex Item 2</div>
		<div class="bg-success p-2">Flex Item 3</div>
	</div>

	<!-- Mini Activity -->
	<h3 class="text-center my-5">Mini Activity with Flex Row</h3>
	<div class="d-flex flex-row align-items-center justify-content-center bg-dark mb-4" style="height:50vh;">
		<div class="bg-primary p-2">Mini 1</div>
		<div class="bg-danger p-2">Mini 2</div>
		<div class="bg-success p-2">Mini 3</div>
	</div>

	<div class="d-flex flex-row align-items-center justify-content-between bg-dark mb-4" style="height:50vh;">
		<div class="bg-primary p-2">Mini 1</div>
		<div class="bg-danger p-2">Mini 2</div>
		<div class="bg-success p-2">Mini 3</div>
	</div>


	<!-- Flex Column -->
	<h2 class="text-center my-5">Flex Column with Align Items and Justify Content</h2>

	<!-- For flex-row and flex-reverse, align-items aligns our flex-row vertically, justify-content aligns our flex-row and flex-row-reverse horizontally.

	For flex-column and flex-column-reverse, aligns-items aligns our flex-column and flex-column-reverse horizontally, justify-content aligns our flex-column and flex-column-reverse vertically.


	 -->

	<!-- Horizontally is x-axis  -->
	<div class="d-flex flex-column align-items-center bg-dark mb" style="height: 50vh">
		<div class="bg-primary p-2" style="width:20%">Mini 1</div>
		<div class="bg-danger p-2" style="width:20%">Mini 2</div>
		<div class="bg-success p-2" style="width:20%">Mini 3</div>
	</div>

	<!-- Center Vertically - y-axis is up and down -->
	<div class="d-flex flex-column justify-content-center bg-dark mb" style="height: 50vh">
		<div class="bg-primary p-2" style="width:20%">Mini 1</div>
		<div class="bg-danger p-2" style="width:20%">Mini 2</div>
		<div class="bg-success p-2" style="width:20%">Mini 3</div>
	</div>

	<!-- Mini Activity -->
	<h3 class="text-center my-5">Mini Activity with Flex Columns</h3>

	<!-- top-left -->
	<div class="d-flex flex-column justify-content-end bg-dark mb-4" style="height:50vh;">
		<div class="bg-primary p-2" style="width:20%">Mini 1</div>
		<div class="bg-danger p-2" style="width:20%">Mini 2</div>
		<div class="bg-success p-2" style="width:20%">Mini 3</div>
	</div>

	<!-- top-right -->
	<div class="d-flex flex-column align-items-end bg-dark mb-4" style="height:50vh;">
		<div class="bg-primary p-2" style="width:20%">Mini 1</div>
		<div class="bg-danger p-2" style="width:20%">Mini 2</div>
		<div class="bg-success p-2" style="width:20%">Mini 3</div>
	</div>

	<!-- Justify  -->
	<h3 class="text-center my-5">Flex Column with Justify Content Between and Around</h3>

	<!-- Space between column (vertical) -->
	<div class="d-flex flex-column justify-content-between bg-dark mb-4" style="height:50vh;">
		<div class="bg-primary p-2" style="width:20%">Mini 1</div>
		<div class="bg-danger p-2" style="width:20%">Mini 2</div>
		<div class="bg-success p-2" style="width:20%">Mini 3</div>
	</div>

	<!-- Top and Bottom yung space (horizontal)-->
	<div class="d-flex flex-column justify-content-around bg-dark mb-4" style="height:50vh;">
		<div class="bg-primary p-2" style="width:20%">Mini 1</div>
		<div class="bg-danger p-2" style="width:20%">Mini 2</div>
		<div class="bg-success p-2" style="width:20%">Mini 3</div>
	</div>

	<!-- FLEX WRAP -->
	<h3 class="text-center my-5">Flex Wrap</h3>
	<div class="d-flex flex-row flex-wrap justify-content-around bg-dark mb-4">
		<div class="bg-primary p-2">Mini 1</div>
		<div class="bg-danger p-2">Mini 2</div>
		<div class="bg-success p-2">Mini 3</div>
		<div class="bg-primary p-2">Mini 4</div>
		<div class="bg-danger p-2">Mini 5</div>
		<div class="bg-success p-2">Mini 6</div>
		<div class="bg-primary p-2">Mini 7</div>
		<div class="bg-danger p-2">Mini 8</div>
		<div class="bg-success p-2">Mini 9</div>
	</div>

	<!-- JS Dependencies -->
	<script src="https://cdn.jsdelivr.net/npm/jquery@3.5.1/dist/jquery.slim.min.js" integrity="sha384-DfXdz2htPH0lsSSs5nCTpuj/zy4C+OGpamoFVy38MVBnE+IbbVYUew+OrCXaRkfj" crossorigin="anonymous"></script>
	
	<script src="https://cdn.jsdelivr.net/npm/popper.js@1.16.1/dist/umd/popper.min.js" integrity="sha384-9/reFTGAW83EW2RDu2S0VKaIzap3H66lZH81PoYlFhbGU+6BZp6G7niu735Sk7lN" crossorigin="anonymous"></script>

	<script src="https://cdn.jsdelivr.net/npm/bootstrap@4.6.1/dist/js/bootstrap.min.js" integrity="sha384-VHvPCCyXqtD5DqJeNxl2dtTyhF78xXNXdkwX1CZeRusQfRKp+tA7hAShOK/B/fQ2" crossorigin="anonymous"></script>
</body>
</html>